// DefaultSystem.cpp: implementation of the DefaultSystem class.
//
//////////////////////////////////////////////////////////////////////

#include "main.h"
#include <conio.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

DefaultSystem::DefaultSystem()
{
	name = "system";
}

DefaultSystem::~DefaultSystem()
{

}


Value DefaultSystem::callFunction(String &funcName, vector<Value> &params, BaseObject *context)
{
	if(funcName == "print")
	{
		CHECKCOUNT(params.size() == 1);
		params[0].convString();
		cout << (char*)*(params[0].s);
		return Value();

	} else if(funcName == "input") {
		CHECKCOUNT(params.size() == 0);

		char buffer[1000];

		cin >> buffer;
	
		return Value(String(buffer));

	} else if(funcName == "waitKey") {
		CHECKCOUNT(params.size() == 0);

		getch();
		
		return Value();

	} else if(funcName == "int") {
		CHECKCOUNT(params.size() == 1);

		params[0].convInt();
		return params[0];
	
	} else if(funcName == "float") {
		CHECKCOUNT(params.size() == 1);

		params[0].convFloat();
		return params[0];

	} else if(funcName == "string") {
		CHECKCOUNT(params.size() == 1);

		params[0].convString();
		return params[0];
	} else if(funcName == "rand") {
		CHECKCOUNT(params.size() == 1);
		params[0].convInt();
		

		return Value(rand() % params[0].i);
	} else {


		throw LangError ("Function not found in NativeObject", __CURPOS__);
	}
}