// ValueNode.h: interface for the ValueNode class.
//
// The ValueNode class describes an individual term
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VALUENODE_H__250CB2C1_0C5D_11D7_BF14_444553540001__INCLUDED_)
#define AFX_VALUENODE_H__250CB2C1_0C5D_11D7_BF14_444553540001__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////// Constants ///////////////
enum ExpTermType
{
	none,
	stringLiteral,			
	numericLiteral,         
	symbol,                 
	block,                  
	prefixOp,               
	paramList,
	arrayDimensions
};

class ExpTerm  
{
public:
	
	String str; // The string representation of a term
	char oper; // The operator following this term
	ExpTermType type;
	bool noIndex;
	ExpTerm();
	ExpTerm(const ExpTerm &cpy)
	{
		str = cpy.str;
		oper = cpy.oper;
		type = cpy.type;
		noIndex = cpy.noIndex;
	}
	virtual ~ExpTerm();

};

#endif // !defined(AFX_VALUENODE_H__250CB2C1_0C5D_11D7_BF14_444553540001__INCLUDED_)
