// Function.cpp: implementation of the Function class.
//
//////////////////////////////////////////////////////////////////////

#include "main.h"
#include <string.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Function::Function(String & name_p, String & params, String & body, BaseObject * obj, int lineNum)
{
	StringList statement;
	StringList paramList;

	
	int i;


	// Set the function name
	name = name_p;

	// Parse the parameter list
	params.splitIgnoreAll(',', paramList);

	String word;
	int pos;
	int size = paramList.getSize();

	// check to see if there are no parameters
	if(size == 1 && paramList[0].getLen() == 0) size = 0;
	paramCount = size;
	//vector<String> paramNames;
	//paramNames.resize(size);

	// Create parameter name list
	for(i = 0; i < size; i++)
	{
		String &cur = paramList[i];
		word = cur.getWordAt(0);
		pos = cur.getLastPos() + word.getLen();
		if(word!="var") throw LangError("Expecting 'var' before function parameter", __FILE__);
		localVars.push_back( cur.getWordAt(pos) );
	}

	// Create expression list
	body.splitIgnoreAll(';', statement);
		

	body = String("{") + body;
	body += "}";

	func = new Expression(body, obj, localVars);

/*
	for(i = 0; i < statement.getSize(); i++)
	{
		String &str = statement[i];
		int count = str.countChar('}');
		if(count == 0)
		{
			if(str.getNextChar(0) != 0)
				expList.push_back(new Expression(str, obj, localVars));
		} else {
			char * c = str;
			pos = strrchr(c, '}')-c;
			
			String temp = str.getSubString(0, pos);
			if(temp.getNextChar(0) != 0)
				expList.push_back(new Expression(temp, obj, localVars));
			
			temp = str.getSubString(pos+1, str.getLen());
			if(temp.getNextChar(0) != 0)
				expList.push_back(new Expression(temp, obj, localVars));
		}
	}
	*/
	//Expression * e = expList[4];
	



}

Function::~Function()
{
	//for(int i = 0; i < expList.size(); i++)
	//{
		//delete expList[i];
	//}

	delete func;
}



Value Function::execute(BaseObject *obj, vector<Value> &params)
{

	if(paramCount != params.size()) throw LangError("Paramter count mismatch");
	
	params.resize(localVars.size()+params.size(), Value());
	
	Value ret = func->evaluate(obj, params);

	ret.flags = 0;

	return ret;
}
