// RefList.cpp: implementation of the RefList class.
//
//////////////////////////////////////////////////////////////////////

#include "main.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RefList::RefList()
{
	head = 0;
}

RefList::~RefList()
{
	RefNode *node;
	while(head)
	{
		node=head;
		head=head->next;
		node->refPtr->objectDestroyed();
		delete node;
	}
}

void RefList::addRef(Value *ref)
{
	if(!head)
	{
		head=new RefNode(ref, 0);
	} else {
		head=new RefNode(ref, head);
	}
}

void RefList::removeRef(Value *ref)
{
	RefNode *node, *prev = 0;
	for(node = head; node; node = node->next)
	{
		if(node->refPtr==ref)
		{
			if(head==node)
			{
				head=node->next;
				delete node;
			} else {
				prev->next=node->next;
				delete node;
			}
			return;
		}
		prev=node;
	}
	throw LangError("Unexpected situation", "RefList::removeRef()", true);
}

// Used for garbage collection
bool RefList::isEmpty()
{
	return (head==0);

}
