// Script.h: interface for the Script class.
//
// The Script class is the main class interfaced by the host application.
// It loads the script files, does all high level parsing (which is promptly
// handed off to Object classes) and acts as an interface to the Objects
// declared by the loaded script. Multiple scripts can be loaded through
// multiple instances of the Script class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCRIPT_H__D85E4C69_AD3B_11D2_A7BD_00502C00951D__INCLUDED_)
#define AFX_SCRIPT_H__D85E4C69_AD3B_11D2_A7BD_00502C00951D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Script  
{
public:
	void deleteObject(BaseObject *obj);
	void garbageCollect();
	Script();
	Script(const char *filename);
	virtual ~Script();

	void flush();
	BaseObject * getSystem();
	//void getAllSubclass(List<BaseObject *> &list, BaseObject *base);
	//void getAllObjects(List<BaseObject *> &list);
	void registerDefSystem();
	void addObject(BaseObject * object);
	void loadScript(const char *fileName);
	BaseObject * getObject(const String &name);

	String lastFunction;
	String lastClass;

private:
	bool isLoaded;
	BaseObject * sys;

	vector<BaseObject *> objList;

	int checkName(String &name);
	void removeTabs(String &str);
	void parse(String &str);
	StringList preParse(const char *filename);

};

#endif // !defined(AFX_SCRIPT_H__D85E4C69_AD3B_11D2_A7BD_00502C00951D__INCLUDED_)
