// StringList.cpp: implementation of the StringList class.
//
//////////////////////////////////////////////////////////////////////

#include "main.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

StringList::StringList(long count)
{
	list = new String[count];
	size = count;
}

StringList::StringList(const StringList &cpy)
{
	size = cpy.size;
	list = new String[size];
	for(long i=0; i<size; i++)
		list[i]=cpy.list[i];
}

StringList::StringList()
{
	list=new String[1];
	size=1;
}

StringList::~StringList()
{
	delete [] list;
}

String &StringList::operator [](long num)
{
	if(num<0 || num>=size) throw LangError("Index out of bounds", "StringList::operator []", true);
	return list[num];
}

void StringList::operator =(const StringList &cpy)
{
	delete [] list;
	size = cpy.size;
	list = new String[size];
	for(long i=0; i<size; i++)
		list[i]=cpy.list[i];
}

void StringList::resize(long count)
{
	delete [] list;
	size=count;
	list=new String[count];
}

void StringList::deleteString(long num)
{
	if(num<0 || num>=size) throw LangError("Index out of bounds", "StringList::deleteString(long num)", true);
	size--;
	String *listT = new String[size];
	for(long i=0; i<num; i++)
	{
		listT[i]=list[i];
	}

	for(i=num+1; i<size+1; i++)
	{
		listT[i-1]=list[i];
	}
	delete [] list;
	list=listT;
}

String StringList::implode(const String &glue)
{
	String ret;
	for(long i=0; i<size-1; i++)
	{
		ret+=list[i];
		ret+=glue;
	}
	ret+=list[size-1];
	return ret;
}

void StringList::insertList(const StringList &StrList, long pos)
{
	if(pos<0 || pos>size) throw LangError("Index out of bounds", "StringList::insertList(const StringList &StrList, long pos)", true);
	String *listT = new String[size + StrList.size];
	for(long i=0; i<pos; i++)
	{
		listT[i]=list[i];
	}

	for(i=0; i<StrList.size; i++)
	{
		listT[pos + i]=StrList.list[i];
	}

	for(i=pos; i<size; i++)
	{
		listT[StrList.size + i]=list[i];
	}

	size = StrList.size + size;
	delete [] list;
	list=listT;
	
}