// Timer.cpp: implementation of the Timer class.
//
//////////////////////////////////////////////////////////////////////

#include "Timer.h"
#include <windows.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Timer::Timer()
{
	LARGE_INTEGER f;
	QueryPerformanceFrequency(&f);
	freq = f.QuadPart;

	LARGE_INTEGER s;
	QueryPerformanceCounter(&s);
	start = s.QuadPart;
}

Timer::~Timer()
{

}

void Timer::reset()
{
	LARGE_INTEGER s;
	QueryPerformanceCounter(&s);
	start = s.QuadPart;
}

float Timer::elapsed()
{
	LARGE_INTEGER e;
	QueryPerformanceCounter(&e);
	__int64 end = e.QuadPart;

	return float(end-start) / freq;
}
