// VarList.cpp: implementation of the VarList class.
//
//////////////////////////////////////////////////////////////////////

#include "main.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// This is used for the instantiation of new classes
VarList::VarList(VarList &copy) : nameList(copy.nameList), valList(copy.valList.size())
{

}

VarList::VarList() : nameList(0), valList(0)
{

}

// Nothing to do, no dyn mem to deallocate
VarList::~VarList()
{
	
}

//////////////////////////////////////////////////////////////////////
// Operators
//////////////////////////////////////////////////////////////////////

void VarList::operator =(VarList &cpy)
{
	nameList = cpy.nameList;
	valList.resize(nameList.size());
}

// This function is extremely fast. It might be a good idea to inline it
Value & VarList::operator [](int index)
{
	return valList[index];
}

// This function is much slower than the integer based indexing function.
// The integer based index is O(1), while this is O(n)
Value & VarList::operator [](String &index)
{
	for(unsigned int i = 0; i < nameList.size(); i++)
	{
		if(nameList[i] == index) return valList[i];
	}
	throw LangError("Member variable not found", __CURPOS__);
}


/*
Node<String> * VarList::getNodeList()
{
	if(nameList.getSize()==0) return 0;
	Node<String> * ret = new Node<String>;
	Node<String> * node = ret;
	node->data = nameList[0];
	for(int i=1; i<nameList.getSize(); i++)
	{
		node->next = new Node<String>(nameList[i]);
		node = node->next;
	}
	return ret;
}
*/


int VarList::getIndex(String & str)
{
	for(unsigned int i = 0; i<nameList.size(); i++)
	{
		if(str == nameList[i]) return i;
	}
	return -1;
}

void VarList::addVar(String &name)
{
	nameList.push_back(name);
	valList.push_back(Value());
}

void VarList::getList(VarList &list)
{
	list.nameList = nameList;
	list.valList.resize(valList.size());
}