// String.h: interface for the String class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STRING_H__848DE540_ED1B_11D6_9823_00045A6922C3__INCLUDED_)
#define AFX_STRING_H__848DE540_ED1B_11D6_9823_00045A6922C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class String  
{
	char *str;
	long len;
	void assign(const char *str);
	void allocate(long size);
public:
	void splitParamList(vector<String> &list);
	String getVarDecAt(int pos);
	String getBracketBlockAt(int pos); // Bracket = '[', ']'
	void splitIgnoreAll(char splt, StringList &list);
	String getNumericAt(int pos);
	void splitIgnoreLiteral(char split, StringList &list);
	String getParenBlockAt(long pos);
	String getArrayDimensionBlockAt(long pos); // Gets a block of text specifying array dimensions, IE: "[5][4]"
	String getStatementAt(long pos);
	String getCodeBlockAt(long pos);
	long getLastPos(); // Returns the LastPos member
	char getNextChar(int pos);
	String getSubString(long start, long end);
	String getLiteralAt(int pos, int &escCount);
	String getWordAt(int pos);
	void trimWhitespace();
	long getLine(int pos); // Returns the number of newline characters from the start of the string to index pos
	inline long const getLen() { return len; };


// Constructors/Destructors
	String();
	String(const char *cpy);
	String(const String &cpy);
	String(long bufferSize);

	virtual ~String();
	
// Operators

	String operator +(const String &add);
	String operator +(const int add);
	void operator +=(const String &add);
	void operator =(const String &cpy);
	int operator ==(const String &cmp);
	int operator ==(const char *cmp);
	int operator !=(const String &cmp);
	int operator !=(const char *cmp);
	int operator >(const String &cmp);
	int operator <(const String &cmp);
	int operator >=(const String &cmp);
	int operator <=(const String &cmp);
	operator char *();
	operator const char *() const;





	// Manipulation functions

	void split(char splChar, StringList &list);
	long countChar(char target);  // Count the occurence of a char
	void loadFile(const char *filename); // Load an entire file into string

	// Static conversion functions

	
	static String toString(int i)
	{
		char buffer[50];
		sprintf(buffer, "%d", i);
		return String(buffer);
	}

	static String toString(char c)
	{
		char buffer[2];
		buffer[0] = c;
		buffer[1] = 0;
		return String(buffer);
	}

private:
	long lastPos;
};

#endif // !defined(AFX_STRING_H__848DE540_ED1B_11D6_9823_00045A6922C3__INCLUDED_)
