#include "main.h"
#include "timer.h"
#include <crtdbg.h>

#define START_MEM()  _CrtMemState state1,state2,state3; _CrtMemCheckpoint(&state1); { do { } while(0)
#define END_MEM()  } _CrtMemCheckpoint(&state2); _CrtMemDifference(&state3,&state1,&state2); _CrtMemDumpStatistics(&state3); do { } while(0)





vector<String> params;

bool hasOption(String opt)
{
	for(unsigned int i=1; i<params.size(); i++)
	{
		if(opt == params[i]) return true;
	}
	return false;
}

int main(int argc, char *argv[ ])
{

#ifndef _DEBUG
	if(argc == 1)
	{
		cout << "Usage:" << endl 
			<< "BASE filename [-t] [-s]" << endl << endl
			<< "-t\tShow execution time of script" << endl
			<< "-s\tSuppress error messages" << endl << endl;
		return 1;
	}



	for(int i=1; i<argc; i++)
	{
		params.push_back(argv[i]);
		params[i-1].trimWhitespace();
	}
#else

	params.push_back("test.txt");

#endif

	
	Timer t;

	{
	START_MEM();

	Script s;
	try
	{
		

		s.loadScript(params[0]);

		
		
		s.addObject((BaseObject*)(new DefaultSystem()));
		
		BaseObject *obj = s.getObject("app");
		
		
		
		t.reset();
		
		Value v = obj->callFunction("main");
		
		float elapse = t.elapsed();

		//v.convString();

		
		if(hasOption("-t"))
		{
			cout << "\n------------------------------------------------\n";
			cout << "Program executed: " << elapse << " seconds" << endl << endl;
		}
		
		//v.convInt();

		//s.garbageCollect();
		//v = obj->callFunction("main");
		//s.garbageCollect();
		//return v.i;
	} catch (LangError e)
	{
		if(!hasOption("-s"))
		{
#ifdef _DEBUG
			cout << (char*)e.errText << "\nLocation:" << (char*)e.errLocation << endl;
#else
            cout << (char*)e.errText << endl;
#endif

		}
	}


	END_MEM();
	}
	return 0;
}